/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * @file           : main.h
  * @brief          : Header for main.c file.
  *                   This file contains the common defines of the application.
  ******************************************************************************
  * @attention
  *
  * <h2><center>&copy; Copyright (c) 2020 STMicroelectronics.
  * All rights reserved.</center></h2>
  *
  * This software component is licensed by ST under Ultimate Liberty license
  * SLA0044, the "License"; You may not use this file except in compliance with
  * the License. You may obtain a copy of the License at:
  *                             www.st.com/SLA0044
  *
  ******************************************************************************
  */
/* USER CODE END Header */

/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __MAIN_H
#define __MAIN_H

#ifdef __cplusplus
extern "C" {
#endif

/* Includes ------------------------------------------------------------------*/
#include "stm32f1xx_hal.h"

/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */
#include <stdint.h>
/* USER CODE END Includes */

/* Exported types ------------------------------------------------------------*/
/* USER CODE BEGIN ET */

/* USER CODE END ET */

/* Exported constants --------------------------------------------------------*/
/* USER CODE BEGIN EC */

/* USER CODE END EC */

/* Exported macro ------------------------------------------------------------*/
/* USER CODE BEGIN EM */
extern ADC_HandleTypeDef hadc1;
extern DMA_HandleTypeDef hdma_adc1;
/* USER CODE END EM */

/* Exported functions prototypes ---------------------------------------------*/
void Error_Handler(void);

/* USER CODE BEGIN EFP */

/* USER CODE END EFP */

/* Private defines -----------------------------------------------------------*/
#define BOOT_LED_Pin GPIO_PIN_15
#define BOOT_LED_GPIO_Port GPIOC
#define DL_TX_DET_Pin GPIO_PIN_0
#define DL_TX_DET_GPIO_Port GPIOA
#define DL_RX_DET_Pin GPIO_PIN_1
#define DL_RX_DET_GPIO_Port GPIOA
#define DC_FAIL_ALARM_Pin GPIO_PIN_2
#define DC_FAIL_ALARM_GPIO_Port GPIOA
#define PAU_TEMP_Pin GPIO_PIN_3
#define PAU_TEMP_GPIO_Port GPIOA
#define PAU_RESERVED0_Pin GPIO_PIN_6
#define PAU_RESERVED0_GPIO_Port GPIOA
#define PAU_RESERVED1_Pin GPIO_PIN_7
#define PAU_RESERVED1_GPIO_Port GPIOA
#define PAU_RESERVED3_Pin GPIO_PIN_0
#define PAU_RESERVED3_GPIO_Port GPIOB
#define PAU_RESERVED2_Pin GPIO_PIN_1
#define PAU_RESERVED2_GPIO_Port GPIOB
#define OVER_POWER_ALARM_Pin GPIO_PIN_12
#define OVER_POWER_ALARM_GPIO_Port GPIOB
#define VSWR_ALARM_Pin GPIO_PIN_13
#define VSWR_ALARM_GPIO_Port GPIOB
#define PAU_RESET_Pin GPIO_PIN_14
#define PAU_RESET_GPIO_Port GPIOB
#define PAU_EN_Pin GPIO_PIN_15
#define PAU_EN_GPIO_Port GPIOB
#define AMP_EN_Pin GPIO_PIN_8
#define AMP_EN_GPIO_Port GPIOA
#define OVER_INPUT_ALARM_Pin GPIO_PIN_11
#define OVER_INPUT_ALARM_GPIO_Port GPIOA
#define OVER_TEMP_ALARM_Pin GPIO_PIN_12
#define OVER_TEMP_ALARM_GPIO_Port GPIOA
#define ALC_ALARM_Pin GPIO_PIN_3
#define ALC_ALARM_GPIO_Port GPIOB
/* USER CODE BEGIN Private defines */

/* USER CODE END Private defines */

#ifdef __cplusplus
}
#endif

#endif /* __MAIN_H */

/************************ (C) COPYRIGHT STMicroelectronics *****END OF FILE****/
